//= require <dSS/devices/device-settings/device-type-panels/DeviceSettingsFCUView>
//= require <dSS/devices/device-settings/device-type-panels/DeviceSettingsVdcConfigLinkView>
//= require <dSS/devices/device-settings/device-type-panels/DeviceSettingsVideoView>
//= require <dSS/devices/device-settings/device-type-panels/DeviceSettingsDefaultView>

Ext.namespace("dSS", "dSS.devices", "dSS.gthelper");

dSS.devices.DeviceSettingsWindow = Ext.extend(Ext.Window, {
    constructor: function(config) {
        this.HEIGHT_OFFSET = 130;

        if ((config.devices === undefined) || (config.index === undefined) ||
            (config.devices.length === 0)) {
            Ext.Msg.alert(dSS._("Error"), dSS._("No information for device"));
            return;
        }

        var mainPanel = new dSS.devices.DeviceSettingsRootPanel({
            devices: config.devices,
            index: config.index,
            rowSel: config.rowSel,
            border: false,
        });

        Ext.apply(this, {
            layout: 'fit',
            padding: 10,
            resizable: false,
            height: 306,
            width: dSS.gthelper.getDialogConfig('deviceSettingsWindowWidth'),
            title: dSS._("Device settings"),
            items: [ mainPanel ]
        });

        dSS.devices.DeviceSettingsWindow.superclass.constructor.apply(this,
                                                                     arguments);

        mainPanel.on('updatetitleicon', function(icon) {
            this.setIconClass(icon);
        },
        this);

        mainPanel.on('close', function() {
            this.close();
        },
        this);

        this.on('afterrender', function() {
            if (config.maskElement !== undefined) {
                config.maskElement.mask();
            }
        },
        this);

        this.on('close', function() {
            if (config.maskElement !== undefined) {
                config.maskElement.unmask();
            }
        },
        this);

        mainPanel.on('updateshadow', function(height) {
            this.setHeight(height + this.HEIGHT_OFFSET);
            var s = this.getEl().shadow;
            if (s) {
                s.realign(this.x, this.y, this.getWidth(), this.getHeight());
            }
        },
        this);
    }
});