Ext.namespace("dSS", "dSS.devices", "dSS.devices.components");

dSS.devices.components.BrightnessLabel = Ext.extend(Ext.form.Label, {
    constructor: function () {
        dSS.devices.components.BrightnessLabel.superclass.constructor.call(this, {
            ref: 'brightnessLabel',
            x: 10,
            y: 16,
            text: dSS._("Brightness") + ':'
        });
    }
});
dSS.devices.components.BrightnessUnitLabel = Ext.extend(Ext.form.Label, {
    constructor: function (config) {
        dSS.devices.components.BrightnessUnitLabel.superclass.constructor.call(this, Object.assign({}, {
            x: 0,
            y: 16,
            ref: 'brightnessPostLabel',
            text: '%'
        }, config));
    }
});
dSS.devices.components.BrightnessField = Ext.extend(Ext.form.NumberField, {
    constructor: function (config) {
        dSS.devices.components.BrightnessField.superclass.constructor.call(this, Object.assign({}, {
            ref: 'brightnessField',
            x: 0,
            y: 12,
            width: 50,
            allowBlank: false,
            allowNegative: false,
            allowDecimals: false,
            forceDecimalPrecision: true,
            decimalPrecision: 0,
            value: 0,
            minValue: 0,
            maxValue: 100
        }, config));
    }
});
dSS.devices.components.BrightnessSlider = Ext.extend(Ext.slider.SingleSlider, {
    constructor: function (config) {
        dSS.devices.components.BrightnessSlider.superclass.constructor.call(this, Object.assign({}, {   
            ref: 'brightnessSlider',
            x: 0,
            y: 12,
            height: 150,
            forceDecimalPrecision: true,
            decimalPrecision: 0,
            value: 0,
            minValue: 0,
            maxValue: 100,
            vertical: true,
            increment: 1,
            plugins: new Ext.slider.Tip({
                getText: function(thumb) {
                    return String.format('{0}%', thumb.value);
                }
            })
        }, config));
    }
});
dSS.devices.components.MaxButton = Ext.extend(Ext.Button, {
    constructor: function (config) {
        dSS.devices.components.MaxButton.superclass.constructor.call(this, Object.assign({}, {   
            ref: 'maxButton',
            x: 0,
            y: 12,
            text: dSS._("Max"),
            tooltip: dSS._("Set maximum value"),
            width: 130
        }, config));
    }
});
dSS.devices.components.IncButton = Ext.extend(Ext.Button, {
    constructor: function (config) {
        dSS.devices.components.IncButton.superclass.constructor.call(this, Object.assign({}, {   
            ref: 'incButton',
            x: 0,
            y: 54,
            iconCls: 'buttonUpIcon',
            tooltip: dSS._("Increase value"),
            width: 130
        }, config));
    }
});
dSS.devices.components.DecButton = Ext.extend(Ext.Button, {
    constructor: function (config) {
        dSS.devices.components.DecButton.superclass.constructor.call(this, Object.assign({}, {   
            ref: 'decButton',
            x: 0,
            y: 98,
            iconCls: 'buttonDownIcon',
            tooltip: dSS._("Decrease value"),
            width: 130,
        }, config));
    }
});
dSS.devices.components.MinButton = Ext.extend(Ext.Button, {
    constructor: function (config) {
        dSS.devices.components.MinButton.superclass.constructor.call(this, Object.assign({}, {   
            ref: 'minButton',
            x: 0,
            y: 140,
            text: dSS._("Min"),
            tooltip: dSS._("Set minimum value"),
            width: 130,
        }, config));
    }
});

dSS.devices.components.TemperatureHint = Ext.extend(Ext.form.Label, {
    constructor: function () {
        dSS.devices.components.TemperatureHint.superclass.constructor.call(this, {
            ref: 'temperatureHint',
            x: 10,
            y: 163,
            width: 211,
            text: dSS._("Entered temperature may be adjusted due to device value rounding."),
            style: {
                opacity: '0.3',
                transform: 'translateY(-100%)',
                fontSize: '11px'
            }
        });
    }
});
dSS.devices.components.TemperatureLabel = Ext.extend(Ext.form.Label, {
    constructor: function () {
        dSS.devices.components.TemperatureLabel.superclass.constructor.call(this, {
            ref: 'temperatureLabel',
            x: 10,
            y: 178,
            text: dSS._("Temperature") + ':'
        });
    }
});
dSS.devices.components.TemperatureField = Ext.extend(Ext.form.NumberField, {
    constructor: function (config) {
        dSS.devices.components.TemperatureField.superclass.constructor.call(this, Object.assign({}, {
            ref: 'temperatureField',
            x: 0,
            y: 174,
            width: 50,
            allowBlank: false,
            allowNegative: false,
            allowDecimals: false,
            forceDecimalPrecision: true,
            decimalPrecision: 0,
            value: 3500,
            minValue: 2200,
            maxValue: 6500,
            increment: 1,
        }, config));
    }
});
dSS.devices.components.TemperatureSlider = Ext.extend(Ext.slider.SingleSlider, {
    constructor: function (config) {
        dSS.devices.components.TemperatureSlider.superclass.constructor.call(this, Object.assign({}, {   
            ref: 'temperatureSlider',
            x: 0,
            y: 174,
            width: 160,
            forceDecimalPrecision: true,
            decimalPrecision: 0,
            value: 3500,
            minValue: 2200,
            maxValue: 6500,
            increment: 1,
            vertical: false,
            plugins: new Ext.slider.Tip({
                getText: function(thumb) {
                    return String.format('{0} K', thumb.value);
                }
            })
        }, config));
    }
});

dSS.devices.components.KelvinMinLabel = Ext.extend(Ext.form.Label, {
    constructor: function (config) {
        dSS.devices.components.KelvinMinLabel.superclass.constructor.call(this, Object.assign({}, {
            ref: 'kelvinMinLabel',
            x: 0,
            y: 200,
            text: 2200
        }, config));
    }
});
dSS.devices.components.KelvinLabel = Ext.extend(Ext.form.Label, {
    constructor: function (config) {
        dSS.devices.components.KelvinLabel.superclass.constructor.call(this, Object.assign({}, {
            ref: 'kelvinLabel',
            x: 0,
            y: 200,
            text: dSS._("Kelvin")
        }, config));
    }
});
dSS.devices.components.KelvinMaxLabel = Ext.extend(Ext.form.Label, {
    constructor: function (config) {
        dSS.devices.components.KelvinMaxLabel.superclass.constructor.call(this, Object.assign({}, {
            ref: 'kelvinMaxLabel',
            x: 0,
            y: 200,
            text: 2200
        }, config));
    }
});

dSS.devices.components.SwitchToColorModeButton = Ext.extend(Ext.Button, {
    constructor: function (config) {
        dSS.devices.components.SwitchToColorModeButton.superclass.constructor.call(this, Object.assign({}, {
            ref: 'switchToTheOtherColorPicker',
            width: '47%',
            x: '50%',
            y: 230,
            text: dSS._("Switch to color mode")
        }, config));
    }
});
dSS.devices.components.SwitchToTemperatureModeButton = Ext.extend(Ext.Button, {
    constructor: function (config) {
        dSS.devices.components.SwitchToTemperatureModeButton.superclass.constructor.call(this, Object.assign({}, {
            ref: 'switchToTheOtherColorPicker',
            width: '47%',
            x: '50%',
            y: 297,
            text: dSS._("Switch to temperature mode")
        }, config));
    }
});

